%define _noVersionedDependencies 1

Summary: OpenSSH free Secure Shell (SSH) implementation
Name: openssh
Version: 4.7p1
Release: 1tr
License: BSD
Group: Trustix Official
Source0: ftp://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable/openssh-%{version}.tar.gz
Source1: sshd_config
Source2: sshd.pam
Source3: sshd.init
# Originally from:
# Source4: http://www.nsa.gov/selinux/patches/openssh-selinux.patch
Source4: openssh-3.8p1-selinux.patch
Patch0: openssh-chroot-4.1p1.patch
Patch1: openssh-3.8p1-makecheck.patch
Requires: openssl >= 0.9.5a, zlib >= 1.1.4
BuildRequires: perl, openssl-devel, tcp_wrappers, kerberos5-devel
BuildRequires: zlib-devel >= 1.1.4, pam-devel >= 0.77
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Obsoletes: ssh
URL: http://www.openssh.com/


%package clients
Summary: OpenSSH Secure Shell protocol clients
Requires: %{name} = %{version}
Group: Trustix Official
Obsoletes: ssh-clients


%package server
Summary: OpenSSH Secure Shell protocol server (sshd)
Group: Trustix Official
Obsoletes: ssh-server
PreReq: %{name} = %{version}
PreReq: chkconfig >= 0.9, tsl-utils, coreutils
PreReq: opensshdconf


%package server-config
Summary: OpenSSH Secure Shell protocol server config
Group: Trustix Official
Provides: opensshdconf

%description
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to seperate libraries (OpenSSL).

This package includes the core files necessary for both the OpenSSH
client and server.  To make this package useful, you should also
install openssh-clients, openssh-server, or both.


%description clients
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to seperate libraries (OpenSSL).

This package includes the clients necessary to make encrypted connections
to SSH servers.


%description server
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to seperate libraries (OpenSSL).

This package contains the secure shell daemon. The sshd is the server 
part of the secure shell protocol and allows ssh clients to connect to 
your host.

%description server-config
Config file for the openssh server.



%prep
%setup -q -n %{name}-%{version}
[ -n "%{?use_selinux}" ] && patch -p1 < %{SOURCE4}
%patch0 -p1
%patch1 -p1

%build
[ -n "%{?use_selinux}" ] && RPM_OPT_FLAGS="$RPM_OPT_FLAGS -DWITH_SELINUX"
CFLAGS="$RPM_OPT_FLAGS  -I /usr/include/gssapi" \
    ./configure --prefix=/usr \
                --sysconfdir=/etc/ssh \
                --mandir=%{_mandir}\
                --with-tcp-wrappers \
                --with-ipv4-default \
                --infodir=/usr/share/info \
                --libexecdir=/usr/libexec/ssh \
                --with-pam \
                --with-lastlog=/var/log/lastlog \
                --with-kerberos5 \
                --with-privsep-path=/var/cache/openssh/empty

make


%install
[ -n "$RPM_BUILD_ROOT" -a "RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT/

install -d $RPM_BUILD_ROOT/etc/pam.d/
install -d $RPM_BUILD_ROOT%{_initdir}
install -d $RPM_BUILD_ROOT/usr/libexec/ssh
install -m600 %{SOURCE1} $RPM_BUILD_ROOT/etc/ssh/
install -m644 %{SOURCE2} $RPM_BUILD_ROOT/etc/pam.d/sshd
install -m755 %{SOURCE3} $RPM_BUILD_ROOT%{_initdir}/sshd


%pre server
if [ -z "`getent group sshd`" ]; then
    /usr/sbin/groupadd -g 103 sshd
fi

if [ -z "`getent passwd sshd`" ]; then
    /usr/sbin/useradd -d /no/dir -M -s /no/shell -g 103 -u 103 sshd
fi


%post server
chkconfig --add sshd
/sbin/restart_maybe sshd


%preun server
if [ "$1" = 0 ]
then
    %{_initdir}/sshd stop >&2
    /sbin/chkconfig --del sshd
fi


%clean
[ -n "$RPM_BUILD_ROOT" -a "RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"


%files
%defattr(-,root,root,0755)
%doc ChangeLog OVERVIEW README* INSTALL CREDITS LICENCE TODO RFC.nroff
%attr(0755,root,root) /usr/bin/ssh-keygen
%attr(0755,root,root) /usr/bin/ssh-keyscan
%attr(0644,root,root) %{_mandir}/man1/ssh-keygen.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-keyscan.1*
%attr(0755,root,root) %dir /etc/ssh
%attr(0755,root,root) %dir /usr/libexec/ssh
%attr(4755,root,root) /usr/libexec/ssh/ssh-keysign
%exclude  /usr/share/Ssh.bin

%files clients
%defattr(-,root,root,0755)
%attr(0755,root,root) /usr/bin/scp
%attr(0755,root,root) /usr/bin/sftp
%attr(0755,root,root) /usr/bin/ssh
%attr(0755,root,root) /usr/bin/ssh-add
%attr(0755,root,root) /usr/bin/ssh-agent
%attr(0755,root,root) /usr/bin/slogin
%attr(0644,root,root) %{_mandir}/man1/scp.1*
%attr(0644,root,root) %{_mandir}/man1/sftp.1*
%attr(0644,root,root) %{_mandir}/man1/ssh.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-agent.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-add.1*
%attr(0644,root,root) %{_mandir}/man1/slogin.1*
%attr(0644,root,root) %{_mandir}/man5/ssh_config.5*
%attr(0644,root,root) %config(noreplace) /etc/ssh/ssh_config

%files server
%defattr(-,root,root,0755)
%attr(0755,root,root) /usr/sbin/sshd
%attr(0755,root,root) /usr/libexec/ssh/sftp-server
%attr(0644,root,root) %{_mandir}/man5/sshd_config.5*
%attr(0644,root,root) %{_mandir}/man8/sshd.8*
%attr(0644,root,root) %{_mandir}/man8/sftp-server.8*
%attr(0644,root,root) %{_mandir}/man8/ssh-keysign.8*
%attr(0600,root,root) %config(noreplace) /etc/ssh/moduli
%attr(0644,root,root) %config(noreplace) /etc/pam.d/sshd
%attr(0755,root,root) %{_initdir}/sshd
%attr(0755,root,root) /var/cache/openssh
%attr(0700,root,root) /var/cache/openssh/empty

%files server-config
%defattr(-,root,root,0755)
%attr(0644,root,root) %config(noreplace) /etc/ssh/sshd_config

%changelog
* Wed Sep 05 2007 Nived Gopalan <nived at trustix dot org> 4.7p1-1tr
- New Upstream.

* Thu Mar 15 2007 Nived Gopalan <nived at trustix dot org> 4.6p1-1tr
- New Upstream.
- Added kerberos5 support.

* Mon Feb 26 2007 Nived Gopalan <nived at trustix dot org>
- Rebuilt

* Wed Nov 08 2006 Bipin S <bipin at trustix dot org> 4.5p1-1tr
- New upstream.
- SECURITY Fix: A weakness has been reported in OpenSSH, which 
  can be exploited by malicious people to bypass certain security
  restrictions. The weakness is caused due to an error within the 
  privilege separation monitor, which may weaken the authentication 
  process (SA22771).

* Thu Sep 28 2006 Nived Gopalan <nived at trustix dot org> 4.4p1-1tr
- New Upstream.
- SECURITY Fix: Tavis Ormandy of Google Security Team has reported a
  vulnerability in OpenSSH, which can be exploited by malicious people
  to cause a DoS. If ssh protocol 1 is enabled, this can be exploited
  to cause a DoS due to CPU consumption by sending specially crafted
  ssh packets.

  The Common Vulnerabilities and Exposures project (cve.mitre.org) has
  assigned the names CVE-2006-4924 to this issue.

* Mon Feb 13 2006 Bipin S <bipin at trustix dot org> 4.3p2-1tr
- New upstream.
- Resolved few portability bugs

* Thu Feb 02 2006 Bipin S <bipin at trustix dot org> 4.3p1-1tr
- New Upstream.
- Multiple Bug Fixes

* Wed Jan 25 2006 Bipin S <bipin at trustix dot org> 4,2p1-2tr
- SECURITY Fix: Josh Bressers has reported a weakness in OpenSSH 
  caused due to the insecure use of the "system()" function in 
  scp when performing copy operations using filenames that are 
  supplied by the user from the command line. This can be exploited 
  to execute shell commands with privileges of the user running scp.

  The Common Vulnerabilities and Exposures project (cve.mitre.org) has
  assigned the names CVE-2006-0225 to this issue.

* Tue Sep 06 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 4.2p1-1tr
- New Upstream
- SECURITY: 
  1. An error in handling dynamic port forwardings when no listen
  address is specified, can cause "GatewayPorts" to be incorrectly
  activated.

  2. An error in handling GSSAPI credential delegation can allow a
  user, who did not login using GSSAPI authentication, to be delegated
  with GSSAPI credentials.

* Tue Aug 16 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 4.1p1-4tr
- Added chroot patch for OpenSSH, Fix Bug # 1151

* Tue May 31 2005 Ajith Thampi <ajith at comodo dot com> 4.1p1-2tr
- Cleanup, Removed the realversion macro as not needed.
		
* Fri May 27 2005 Ajith Thampi <ajith at comodo dot com> 4.1p1-1tr
- New Upstream

* Wed Apr 20 2005 Thushara Gopalakrishnan <thushara at comodo dot com>  4.0p1-2tr
- Changed init priority

* Tue Mar 16 2005 Ajith Thampi <ajith at comodo dot com> 4.0p1-1tr
- Rebuilt
- New Upstream.

* Fri Nov 12 2004 Erlend Midttun <erlendbm at trustix dot org> 3.9.0p1-3tr
- Now run sshd -t with full path.

* Tue Nov  9 2004 Oystein Viggen <oysteivi at trustix dot com> 3.9.0p1-2tr
- Rebuild with shared openssl

* Mon Mar 15 2004 Chr. Toldnes <christht at trustix dot com> 3.8.0p1-3tr
- Fixed default sftp subsystem path

* Wed Feb 25 2004 Erlend Midttun <erlendbm at trustix dot org> 3.8.0p1-1tr
- New upstream.

* Tue Feb  3 2004 Oystein Viggen <oysteivi at trustix dot org> 2.7.1p2-3ov
- Conditionally build with selinux support

* Tue Nov 25 2003 Erlend Midttun <erlendbm at trustix dot org> 3.7.1p2-2em
- Now with protocol 2 as default.

* Tue Sep 23 2003 Chr. Toldnes <christht at trustix dot com> 3.7.1p2-1ct
- New upstream: 3.7.1p2

* Tue Sep 23 2003 Chr. Toldnes <christht at trustix dot com> 3.7.1p1-1ct
- New upstream: 3.7.1p1
- Added 4 new fixes from Solar Designer

* Tue Sep 16 2003 Tor Hveem <torh at trustix dot org> 3.7p1-1th
- New upstream

* Mon Aug 25 2003 Chr. Toldnes <christht at trustix dot com> 3.6.1p2-2ct
- Reject SSH1 in default config
- removed oversion, actually use new version.

* Tue Aug  5 2003 Erlend Midttun <erlendbm at trustix dot com> 3.6.1p2-1tr
- New minor upstream.

* Fri Aug  1 2003 Erlend Midttun <erlendbm at trustix dot com> 3.6.1p1-10tr
- ssh no longer setuid.
- ssh-keysign is and moved to the common package.

* Thu Jun 26 2003 Erlend Midttun <erlendbm at trustix dot com> 3.6.1p1-9tr
- No longer remove user on uninstall.
- No longer try to create home directory.

* Mon Jun 23 2003 Erlend Midttun <erlendbm at trustix dot com> 3.6.1p1-8tr
- Added %defattr.

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 3.6.1p1-7tr
- Big rebuild

* Wed Jun 11 2003 Chr. Toldnes <christht at trustix dot com> 3.6.1p1-6ct
- Split sshd_config into own package

* Mon Jun  2 2003 Tore Olsen <toreo at trustix dot com> 3.6.1p1-5to
- rc.d begone

* Wed May 28 2003 Tore Olsen <toreo at trustix dot com> 3.6.1p1-4to
- revert to old-style initscript.

* Mon May 26 2003 Erlend Midttun <erlendbm at trustix dot com> 3.6.1p1-3em
- fileutils -> coreutils.

* Tue Apr 22 2003 Erlend Midttun <erlendbm at trustix dot com> 3.6.1p1-2em
- Added sshd group

* Tue Apr  8 2003 Erlend Midttun <erlendbm at trustix dot com> 3.6.1p1-1em
- New upstream.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 3.5.0p1-10em
- Rebuilt against glibc 2.3.2.

* Mon Mar 10 2003 Gerald Dachs <gda at trustix dot org> 3.5.0p1-9gd
- Initscript uses now $INITLOCK

* Thu Feb 27 2003 Erlend Midttun <erlendbm at trustix dot com> 3.5.0p1-8em
- Make setup quiet.

* Fri Jan 17 2003 Gerald Dachs <gda at trustix dot org> 3.5.0p1-7gd
- recompiled against openssl-0.9.7-1gd

* Mon Jan 13 2003 Goetz Bock <bock at trustix dot org> 3.5.0p1-6bg
- cleaned up spec file
- moved to a TSL version of /etc/init.d/sshd

* Fri Dec 20 2002 Gerald Dachs <gda at trustix dot org> 3.5.0p1-5gd
- fixed path to userdel in %preun

* Fri Dec 20 2002 Goetz Bock <bock at trustix dot org> 3.5.0p1-4bg 
- rebuild with pam 0.77

* Fri Dec 20 2002 Goetz Bock <bock at trustix dot org> 3.5.0p1-3bg
- added some build requirements

* Thu Dec 19 2002 Gerald Dachs <gda at trustix dot org> 3.5.0p1-2gd
- cheated on a version number

* Thu Dec 19 2002 Gerald Dachs <gda at trustix dot org> 3.5.0p1-1gd
- New upstream version: 3.5p1

* Thu Sep  5 2002 Christian H. Toldnes <christht at trustix dot com> 3.4.0p1-2ct
- Added working etc/pam.d/sshd file

* Mon Aug 12 2002 Christian H. Toldnes <christht at trustix dot com> 3.4.0p1-1ct
- New upstream version: 3.4p1
- Removed patch 1 and 2
- Edited patch 3 to not include the contrib .spec.
- Added some new files and man-pages.
- Added user sshd for Privilege separation functionality, along with directory
  /var/empty 

* Thu Jul 18 2002 Roland Kruse <rolandk at trustix dot com> 3.1.0p1-6rk
- sshd initscript fix (Patch3)

* Wed Jul 17 2002 Roland Kruse <rolandk at trustix dot com> 3.1.0p1-5rk
- initscripts /etc/rc.d/init.d -> /etc/init.d

* Fri Apr 26 2002 Christian H. Toldnes <christht at trustix dot com>
- Patched to fix security issue if rebuilt with kerberos support.

* Fri Mar 15 2002 Christian H. Toldnes <christht at trustix dot com>
- Fixed broken ssh-keygen in %post
- Added security Prereq on zlib >= 1.1.4

* Thu Mar  7 2002 Christian H. Toldnes <christht at trustix dot com>
- New upstream version. Now 3.1

* Thu Jan  3 2002 Erlend Midttun <erlendbm at trustix dot com>
- Fixed chkconfig part of startup.

* Fri Dec 21 2001 Erlend Midttun <erlendbm at trustix dot com>
- Fixed file conflictm, take II.

* Thu Dec 20 2001 Erlend Midttun <erlendbm at trustix dot com>
- Fixed file conflict.

* Wed Dec 19 2001 Erlend Midttun <erlendbm at trustix dot com>
- Updated to 3.0.2p1 to fix uselogin security hole.

* Thu Oct  4 2001 Erlend Midttun <erlendbm at trustix dot com>
- New upstream version.  Fixes a weakness in the key file option handling.

* Tue Jul  3 2001 Oystein Viggen <oysteivi at trustix dot com>
- define _noVersionedDependencies

* Mon Jun 18 2001 Oystein Viggen <oysteivi at trustix dot com>
- New upstream version 2.9p2
- Fix bug in default config file

* Mon Jun 11 2001 Erlend Midttun <erlendbm at trustix dot com>
- New upstream version.

* Tue Mar 27 2001 Alexander Reelsen <ar at trustix dot com>
- Upgraded to 2.5.2p2
- Fixed DSA protocol 2 problems

* Mon Feb 19 2001 Oystein Viggen <oysteivi at trustix dot com>
- Get 2.5.1p1, adding an sftp client.

* Wed Nov 29 2000 Erlend Midttun <erlendbm at trustix dot com>
- Fixed typo in group setting.  Thanks to Janke Ronnblom,
  <jan-ake.ronnblom@skeria.skelleftea.se> for pointing this out.

* Wed Nov 15 2000 Erlend Midttun <erlendbm at trustix dot com>
- Updated to 2.3.0p1 to fix some security issues.

* Thu Sep 14 2000 Per Ivar Paulsen <perp at trustix dot com>
- Picked up 2.2.0p1

* Tue Jun 13 2000 Oystein Viggen <oysteivi at trustix dot com>
- Upgraded to version 2.1.1p1

* Wed Jun 07 2000 Erlend Midttun <erlendbm at trustix dot com>
- Added loginprogram hack.
- Added hack to fix utmp/wtmp problems

* Tue Jun 06 2000 Erlend Midttun <erlendbm at trustix dot com>
- Upgraded to version 2.1.0p3

* Thu May 18 2000 Erlend Midttun <erlendbm at trustix dot com>
- Removed X and gnome packages

* Wed Mar 15 2000 Damien Miller <djm@ibs.com.au>
- Updated for new location
- Updated for new gnome-ssh-askpass build

* Sun Dec 26 1999 Damien Miller <djm@mindrot.org>
- Added Jim Knoble's <jmknoble@pobox.com> askpass

* Mon Nov 15 1999 Damien Miller <djm@mindrot.org>
- Split subpackages further based on patch from jim knoble <jmknoble@pobox.com>

* Sat Nov 13 1999 Damien Miller <djm@mindrot.org>
- Added 'Obsoletes' directives

* Tue Nov 09 1999 Damien Miller <djm@ibs.com.au>
- Use make install
- Subpackages

* Mon Nov 08 1999 Damien Miller <djm@ibs.com.au>
- Added links for slogin
- Fixed perms on manpages

* Sat Oct 30 1999 Damien Miller <djm@ibs.com.au>
- Renamed init script

* Fri Oct 29 1999 Damien Miller <djm@ibs.com.au>
- Back to old binary names

* Thu Oct 28 1999 Damien Miller <djm@ibs.com.au>
- Use autoconf
- New binary names

* Wed Oct 27 1999 Damien Miller <djm@ibs.com.au>
- Initial RPMification, based on Jan "Yenya" Kasprzak's <kas@fi.muni.cz> spec.
